/*4:*/
#line 184 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 185 "examples.w"
;

/*:4*//*5:*/
#line 202 "examples.w"

eggdatabases ed;
ed.set_local_defaults();

/*:5*//*6:*/
#line 226 "examples.w"

generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);

/*:6*//*7:*/
#line 238 "examples.w"

egganalysis*esr= ec.get_by_date("2001-04-22");

/*:7*//*8:*/
#line 249 "examples.w"

esr->write_deviation_plot("example-1",
"Earth Day: 2001 April 22",
systemtime::SecondsPerHour
);

/*:8*//*9:*/
#line 259 "examples.w"

/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 260 "examples.w"
;

/*:9*/
