/*17:*/
#line 380 "examples.w"

/*47:*/
#line 964 "examples.w"


/*51:*/
#line 1061 "examples.w"


#include "config.h"         
#define REVDATE "22nd February 2002" \

#define EGGS_CSV "eggs.csv"
#define ROTTEN_CSV "rotten_egg.csv" \


#line 1064 "examples.w"


#include "analysis.h"       
#include "fourier.h"     

#include <stdio.h> 
#include <stdlib.h> 
#ifdef HAVE_GETOPT
#ifdef HAVE_UNISTD_H
#include <unistd.h> 
#endif
#else
#include "getopt.h"     
#endif

/*:51*/
#line 966 "examples.w"
;

/*50:*/
#line 1040 "examples.w"

static void usage(void)
{
cout<<PRODUCT<<"  --  Analyse eggsummary files.  Call:\n";
cout<<"              "<<PRODUCT<<" [options] [infile] [outfile]\n";
cout<<"\n";
cout<<"Options:\n";
cout<<"           --copyright       Print copyright information\n";
cout<<"           -u, --help        Print this message\n";
cout<<"           --version         Print version number\n";
cout<<"\n";
cout<<"by John Walker\n";
cout<<"http://www.fourmilab.ch/\n";
}

/*:50*/
#line 968 "examples.w"
;

int main(int argc,char*argv[])
{
extern char*optarg;
extern int optind;

try{

/*49:*/
#line 1006 "examples.w"

int opt;

while((opt= getopt(argc,argv,"nu-:"))!=-1){
switch(opt){

case'u':
case'?':
usage();
return 0;

case'-':
switch(optarg[0]){
case'c':
cout<<"This program is in the public domain.\n";
return 0;

case'h':
usage();
return 0;

case'v':
cout<<PRODUCT<<" "<<VERSION<<"\n";
cout<<"Last revised: "<<REVDATE<<"\n";
cout<<"The latest version is always available\n";
cout<<"at http://www.fourmilab.ch/eggtools/eggshell\n";
return 0;
}
}
}

/*:49*/
#line 977 "examples.w"
;

/*:47*/
#line 381 "examples.w"
;

eggdatabases ed;
ed.set_local_defaults();
generic_eggsummary_cache<egganalysis> ec(&ed,ROTTEN_CSV,50,150);
egganalysis ext;
ec.extract_time_range(&ext,systemtime("2001-06-01 00:00:00"),
systemtime("2001-06-07 23:59:59"));

/*:17*//*18:*/
#line 394 "examples.w"

ext.compute_per_egg_statistics();

/*:18*//*19:*/
#line 403 "examples.w"

cout<<" Egg Samples      Mean       Max   Min     Std. Dev."<<endl;
cout.setf(ios::fixed,ios::floatfield);
cout.precision(8);
for(int i= 0;i<ext.eggs_reporting;i++){
if(ext.egg_num_sample[i]> 0){
cout<<
setw(4)<<ext.egg_number[i]<<"  "<<
setw(6)<<ext.egg_num_sample[i]<<"  "<<
setw(12)<<ext.egg_mean[i]<<"  "<<
setw(4)<<((int)ext.egg_max_sample[i])<<"  "<<
setw(4)<<((int)ext.egg_min_sample[i])<<"  "<<
setw(12)<<ext.egg_stdev[i]<<endl;
}
}

/*:19*//*20:*/
#line 432 "examples.w"

binomialDistribution pdist(200,0.5);

cout<<endl<<
setw(4)<<"Exp."<<"  "<<
setw(6)<<ext.seconds_of_data<<"  "<<
setw(12)<<pdist.mean()<<"  "<<
setw(4)<<" "<<"  "<<
setw(4)<<" "<<"  "<<
setw(12)<<pdist.stdev()<<endl;

/*48:*/
#line 983 "examples.w"

}catch(exception&e){
cout<<"Blooie!!!  Exception popped: "<<e.what()<<endl;
#ifndef CORE_DUMP
#ifdef STACK_TRACE
char s[160];
sprintf(s,"/bin/echo 'where\nq' >/tmp/gdbcmd ; gdb  -batch --command "
"/tmp/gdbcmd %s %d",argv[0],getpid());
system(s);
sleep(5);
#endif
throw;
#endif
}

return 0;
}


/*:48*/
#line 443 "examples.w"
;

/*:20*/
