/*2:*/
#line 59 "fourier.w"

#include "config.h"                   


#line 62 "fourier.w"


/*4:*/
#line 95 "fourier.w"

#include "fourier.h"       

/*:4*/
#line 64 "fourier.w"

/*12:*/
#line 225 "fourier.w"

void fourierTransform::buildtable(void){
int n,halfn,i;
double theta;
static const double PI2= 6.283185307179586476925287;

n= pwr_two[ln];
halfn= pwr_two[ln-1];
if(c!=NULL){
delete c;
}
c= new complex[halfn];
for(i= 0;i<halfn;i++){
theta= (PI2*i)/n;
c[i].r= cos(theta);
c[i].i= -sin(theta);
}
}

/*:12*//*13:*/
#line 248 "fourier.w"

void fourierTransform::bitreverse(complex*x){
int i,j,k,n;
complex hold;

n= pwr_two[ln];
k= 0;
j= 0;
while(true){
if(k> j){
hold.r= x[j].r;
hold.i= x[j].i;

x[j].r= x[k].r;
x[j].i= x[k].i;

x[k].r= hold.r;
x[k].i= hold.i;
}
j++;
if(j==n){
break;
}




i= ln-1;
while(i>=0){
if(k&pwr_two[i]){
k= k-pwr_two[i];
}else{
break;
}
i--;
}
k= k+pwr_two[i];
}
}

/*:13*//*14:*/
#line 292 "fourier.w"

void fourierTransform::fft(complex*x){
unsigned int stuckbit,stuckbitcomplement,halfn,t,b;
unsigned int shft,msk,wt;
unsigned int c0,c1;
unsigned int n;
double qr,qi,xtr,xti,xbr,xbi,cwtr,cwti;

assert(c!=NULL);
n= pwr_two[ln];
msk= n-1;
halfn= pwr_two[ln-1];
shft= ln-1;

stuckbit= 1;
c0= ln;
while(c0--){
t= 0;
stuckbitcomplement= ~stuckbit;
c1= halfn;
while(c1--){
wt= (t<<shft)&msk;
b= t+stuckbit;

xbr= x[b].r;
xbi= x[b].i;
cwtr= c[wt].r;
cwti= c[wt].i;

qr= xbr*cwtr-xbi*cwti;
qi= xbr*cwti+xbi*cwtr;

xtr= x[t].r;
xti= x[t].i;

x[b].r= xtr-qr;
x[b].i= xti-qi;

x[t].r= xtr+qr;
x[t].i= xti+qi;

t= (b+1)&stuckbitcomplement;
}
stuckbit<<= 1;
shft-= 1;
}
}

/*:14*//*15:*/
#line 347 "fourier.w"

void fourierTransform::ifft(complex*x)
{
unsigned int stuckbit,stuckbitcomplement,halfn,t,b;
unsigned int shft,msk,wt;
unsigned int c0,c1;
unsigned int n;
double qr,qi;

assert(c!=NULL);
n= pwr_two[ln];
msk= n-1;
halfn= pwr_two[ln-1];
shft= ln-1;

stuckbit= 1;
c0= ln;
while(c0--){
t= 0;
stuckbitcomplement= ~stuckbit;
c1= halfn;
while(c1--){
b= t+stuckbit;
wt= (t<<shft)&msk;

qr= x[b].r*c[wt].r+x[b].i*c[wt].i;
qi= -(x[b].r*c[wt].i)+x[b].i*c[wt].r;

x[b].r= x[t].r-qr;
x[b].i= x[t].i-qi;

x[t].r+= qr;
x[t].i+= qi;

t= (b+1)&stuckbitcomplement;
}
stuckbit<<= 1;
shft-= 1;
}
}

/*:15*//*16:*/
#line 393 "fourier.w"

void fourierTransform::power_spectrum(const complex*x,double*p)
{
unsigned int j;

for(j= 0;j<pwr_two[ln];j++){
#define sqr(x) ((x) * (x))
p[j]= sqrt((sqr(x[j].r)+sqr(x[j].i))/pwr_two[ln]);
#undef sqr
}
}

/*:16*/
#line 65 "fourier.w"


/*:2*/
